#include <errno.h>
#include <stdio.h>
#include <stdio_ext.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <string.h>
#include <sys/wait.h>
#include <termios.h>
#include <stdarg.h>

#include "../include/AnalysisModuleInterface.h"
// #include "AnalysisResultManager.h"
#include "PStringToken.h"
#include "UNOImproperInitializationInfo.h"
#include "UNOImproperInitialization.h"
// #include "UNOBoundCheck.h"
// #include "uno.h"

#define MAX_FILENAME_SIZE	256 
#define MAX_ARG_SIZE		512

extern "C" int UnoCheckEx( int argc , char* argv[] , treenode* pParseTree , char* pszFileName );
extern "C" int GetWordCount( char* pBuf , int* nBufLength );

extern "C" bool GetModuleInfo( CAnalysisModuleInfo* pInfo )
{ 
	// printf( "In Extern UnoBoundChecker GetModuleInfo\n" );
	pInfo->m_uiId = MODULE_ID;
	memcpy( pInfo->m_szName , MODULE_NAME , strlen( MODULE_NAME ) );
	pInfo->m_uiRevisionNo = MODULE_REVISION_NO; 

	pInfo->m_uiInputId = IOP_PARSING_RESULT;
	memcpy( pInfo->m_szInputName , PIN_NAME_PARSING_RESULT , strlen( PIN_NAME_PARSING_RESULT ) );
	// pInfo->m_szInputDescription  

	pInfo->m_uiOutputId = IOP_ANALYSIS_RESULT;
	memcpy( pInfo->m_szOutputName , PIN_NAME_ANALYSIS_RESULT , strlen( PIN_NAME_ANALYSIS_RESULT ) );
	// pInfo->m_szOutputDescription 

	return true;
}

extern "C" void	Initialize( CAnalysisNotifyInterface* pInterface , CModuleRelayInterface* pRelayInterface )
{
	g_AnalysisResultManager.Initialize( MODULE_ID , pInterface , pRelayInterface );
}

// extern "C" bool StartProcess( CAnalysisNotifyInterface* pInterface , CInOutPinBase* pInputPin , CInOutPinBase** pOutputPin )
extern "C" bool StartProcess( CInOutPinBase* pInputPin )
{
	char pSep[] = " ";
	char szCheckName[] = "CheckUninitialize";

	char** aArray = NULL;
	char* pTokenData = NULL;

	int nArgSize = 2;
	int i = 0;
	int nInputPinOptionWordCount = 0;
	int nInputPinOptionBufLength = 0;

	PStringToken StringToken;

	pid_t pidChild;

	CParsingResultPin* pParsingResultPin = ( CParsingResultPin* )pInputPin;

	/*
 	nInputPinOptionWordCount = GetWordCount( pParsingResultPin->m_pOption , &nInputPinOptionBufLength );
	nArgSize = nInputPinOptionWordCount + 1;

	printf( "Option = %s , Count = %d , nArgSize = %d\n" , pParsingResultPin->m_pOption , nInputPinOptionWordCount , nArgSize );
	*/	

	aArray = ( char** )malloc( sizeof( char* ) * nArgSize );

	aArray[ 0 ] = ( char* )malloc( strlen( szCheckName ) + 1 );
	memset( aArray[ 0 ] , 0 , strlen( szCheckName ) + 1 );
	aArray[ 1 ] = ( char* )malloc( strlen( pParsingResultPin->m_szFileName ) + 1 );
	memset( aArray[ 1 ] , 0 , strlen( pParsingResultPin->m_szFileName ) + 1 );

	/* for( ; i < nArgSize ; i++ )
	{
		aArray[ i ] = ( char* )malloc( MAX_FILENAME_SIZE );
		memset( aArray[ i ] , 0 , MAX_FILENAME_SIZE );
	} */

	strncpy( aArray[ 0 ] , szCheckName , strlen( szCheckName ) );
	strncpy( aArray[ 1 ] , pParsingResultPin->m_szFileName , strlen( pParsingResultPin->m_szFileName ) );

	UnoCheckEx( nArgSize , aArray , pParsingResultPin->m_pParseTree , pParsingResultPin->m_szFileName );
 	
	FreeArgument( &aArray , nArgSize );
	ExitEx( -1 );
	return 0;
}

void PrintfEx( const char* pFmt , ... )
{
	va_list ptr;	

	char* pszBuf	= NULL;

	int nRt 	= 0;
	int nBeforeRt	= MAX_ARG_SIZE;

	va_start( ptr , pFmt );

	pszBuf = ( char* )malloc( nBeforeRt );
	memset( pszBuf , 0 , sizeof( pszBuf ) );

	nRt = vsnprintf( pszBuf , nBeforeRt , pFmt , ptr );
	while( nRt >= nBeforeRt )
	{
		if( pszBuf )
		{
			delete [] pszBuf;
			pszBuf = NULL;
		}

		pszBuf = ( char* )malloc( nRt + 1 );
		memset( pszBuf , 0 , nRt + 1 );

		nBeforeRt = nRt + 1;		
		nRt = vsnprintf( pszBuf , nRt + 1 , pFmt , ptr );
	}

	g_AnalysisResultManager.AddAnalysisResult( pszBuf , nRt );
	g_AnalysisResultManager.ProcessBufferData();	

	// printf( "%s" , pszBuf );
	// printf( "\nnRt = %d\n" , nRt );

	if( pszBuf )
	{
		delete [] pszBuf;
		pszBuf = NULL;
	}

	va_end( ptr );
}

void ExitEx( int nExitNo )
{
	g_AnalysisResultManager.ProcessBufferData( true );

	if( -1 != nExitNo )
	{
		exit( nExitNo );
	}
}

void FreeArgument( char*** pppArgument , int nArgSize )
{
	for( int i = 0; i < nArgSize ; i++ )
	{
		if( ( *pppArgument )[ i ] )
		{
			free( ( *pppArgument )[ i ] );
			( *pppArgument )[ i ] = NULL;
		}
	}

	if( *pppArgument )
	{
		free( *pppArgument );
		*pppArgument = NULL;
	}
}
