#ifndef SWA_MODULE_FILE_TREE_H
#define SWA_MODULE_FILE_TREE_H
#include <gtkmm.h>
using namespace Gtk;
using namespace Glib;
#include <iostream>
using namespace std;

enum
{
	MFT_ITEM_TYPE_PROJECT = 0,
	MFT_ITEM_TYPE_FILE,
	MFT_ITEM_TYPE_INFO,
	MFT_ITEM_TYPE_COUNT,
};

class CModuleFileTreeColumn : public TreeModel::ColumnRecord
{
public:
	CModuleFileTreeColumn()
	{
		add ( m_colIcon );
		add ( m_colItemType );
		add ( m_colName );
		add ( m_colID );
	}

public:
	TreeModelColumn< RefPtr< Gdk::Pixbuf > > m_colIcon;
	TreeModelColumn< int >				m_colItemType;
	TreeModelColumn< ustring >			m_colName;
	TreeModelColumn< int >				m_colID;
};

class CModuleFileTree : public TreeView
{
protected:
	CModuleFileTreeColumn		m_tmcColumns;
	RefPtr<TreeStore>			m_ptsTreeModel;
	RefPtr<TreeSelection>		m_ptsTreeSelection;
	Menu						m_mwPopupMenu;
	CellRendererText			m_CellRendererText;

	vector< int >				m_vecModuleID;
public:
	CModuleFileTree();
	virtual ~CModuleFileTree();
	void cell_data_func( Gtk::CellRenderer* renderer, const Gtk::TreeModel::iterator& iter );
	virtual void SetProjectName( const ustring& strProjectName );
	bool DeleteAllItem( const TreeModel::iterator& itTreeModel );
	virtual void Reset();
	virtual bool on_button_release_event( GdkEventButton* pebEventButton );
	virtual void on_row_activated( const TreeModel::Path& tmPath, TreeViewColumn* ptvColumn );
	void OnMenuReload();
	virtual void on_drag_begin( const Glib::RefPtr<Gdk::DragContext>& context );
	virtual void on_drag_data_get( const Glib::RefPtr<Gdk::DragContext>& context, Gtk::SelectionData& selection_data, guint info, guint time);
	vector< int >* GetSelectedModuleIDList();
protected:
};
#endif


