#ifndef SWA_RESULT_VIEW_H
#define SWA_RESULT_VIEW_H
#include<gtkmm.h>
using namespace Gtk;
using namespace Glib;
#include <string>
#include <vector>
#include <map>
using namespace std;
#include "AnalysisModuleManager.h"

class CResultViewColumnTotal : public TreeModel::ColumnRecord
{
public:
	CResultViewColumnTotal()
	{
		add ( m_strSourceFileName );
		add ( m_nCodeLine );
		add ( m_strErrorText );
		add ( m_nModuleCount );
	}

public:
	TreeModelColumn< ustring >	m_strSourceFileName;
	TreeModelColumn< int >		m_nCodeLine;
	TreeModelColumn< ustring >	m_strErrorText;
	TreeModelColumn< int >		m_nModuleCount;
};

class CResultViewColumnModule : public TreeModel::ColumnRecord
{
public:
	CResultViewColumnModule()
	{
		add ( m_strSourceFileName );
		add ( m_nCodeLine );
		add ( m_strErrorText );
	}

public:
	TreeModelColumn< ustring >	m_strSourceFileName;
	TreeModelColumn< int >		m_nCodeLine;
	TreeModelColumn< ustring >	m_strErrorText;
};

class CResultView : public VBox
{
protected:
	ComboBoxText								m_ComboBoxText;
	ScrolledWindow								m_ScrolledWindow;
	TreeView									m_TreeView;
	
	Glib::RefPtr< Gtk::ListStore >				m_pTreeModelTotal;
	CResultViewColumnTotal						m_ColumnTotal;

	std::map < ustring, RefPtr< ListStore > >	m_mapTreeModelModule;
	CResultViewColumnModule						m_ColumnModule;

	ustring m_strFileName;
	int m_nLineNo;
	ustring m_strErrorText;
	bool m_bFindSameErrorInTotal;
	TreeModel::Row m_rowFindSameErrorInTotal;
public:
	CResultView();
	virtual ~CResultView();
	void OnChangedComboBoxText();
	void SetTreeModelTotal();
	void SetTreeModelModule( ustring strModuleName );
	void AddTreeModelModule( ustring strModuleName );
	void Reset();
	void OnNotifyAnalysisResult ( unsigned int uiModuleId , CAnalysisResultPin* pAnalysisResultPin );
	bool FindSameErrorInTotal( const TreeModel::iterator& itRow );
};
#endif


