#ifndef		SWA_SOURCE_FILE_TREE_H
#define		SWA_SOURCE_FILE_TREE_H

#include <gtkmm.h>

#include <vector>
#include <algorithm>

using namespace Gtk;
using namespace Glib;
using namespace std;

#include <giomm.h>
using namespace Gio;

#include "AnalysisModuleManager.h"

enum
{
	SFT_ITEM_TYPE_PROJECT = 0,
	SFT_ITEM_TYPE_FOLDER,
	SFT_ITEM_TYPE_FILE,
	SFT_ITEM_TYPE_COUNT,
};

class CSourceFileTreeColumn : public TreeModel::ColumnRecord
{
public:
	CSourceFileTreeColumn()
	{
		add ( m_colIcon );
		add ( m_colItemType );
		add ( m_bExpand );
		add ( m_colName );
		add ( m_colFile );
	}

public:
	TreeModelColumn< RefPtr< Gdk::Pixbuf > > m_colIcon;
	TreeModelColumn< int >				m_colItemType;
	TreeModelColumn< bool >				m_bExpand;
	TreeModelColumn< ustring >			m_colName;
	TreeModelColumn< RefPtr< File > >	m_colFile;
};

class CSourceFileTree : public TreeView
{
public:
	CSourceFileTree();
	virtual ~CSourceFileTree();

protected:
	Menu						m_mwPopupMenu;

	ustring						m_strOldLabel;
	CSourceFileTreeColumn		m_tmcColumns;
	CellRendererText			m_CellRendererText;

	RefPtr<TreeStore>			m_ptsTreeModel;
	RefPtr<TreeSelection>		m_ptsTreeSelection;
	RefPtr<FileOutputStream>	m_pFileOutputStream;
	int m_nChildCount;
	RefPtr< File >				m_pSelectedFile;
	RefPtr< FileInputStream >	m_pFileInputStream;
	bool						m_bStopThread;
	CSourceFilePin SourceFilePin;

public:

	virtual void SetProjectName( const ustring& strProjectName );
	virtual void Reset();
	virtual void Save();
	virtual void SaveAs( RefPtr< FileOutputStream > pFileOutputStream );
	virtual void Open( RefPtr< FileInputStream > pFileInputStream ); 

protected:
	virtual void Open( TreeNodeChildren tnChildren, int nChildCount );
	virtual bool SaveRow( const TreeModel::iterator& itRow );
	virtual bool FindFile( const TreeModel::iterator& itTreeModel, RefPtr< File > pfileFile, bool* pbFind );

	void cell_data_func( Gtk::CellRenderer* renderer, const Gtk::TreeModel::iterator& iter );
	virtual bool on_button_release_event( GdkEventButton* pebEventButton );
	virtual void on_row_activated( const TreeModel::Path& tmPath, TreeViewColumn* ptvColumn );
	virtual void OnMenuAddFolder();
	virtual void OnMenuAddFile();
	virtual void OnMenuRemove();
	virtual void OnMenuOpen();
	virtual void OnMenuRename();
	virtual void OnMenuAnalysis();
	virtual void OnMenuStopAnalysis();
	void StartAnalysisThread();
	virtual void OnCellEditingStarted( CellEditable* pceCellEditable, const ustring& strPath );
	virtual void OnCellEdited( const ustring& strPath, const ustring& strNew );

	virtual void on_row_expanded_( const TreeIter& itItem, const TreePath& pathItem );
	virtual void on_row_collapsed_( const TreeIter& itItem, const TreePath& pathItem );
};
#endif


