#include "ViewManager.h"
#include <iostream>		// TEST CODE
using namespace std;	// TEST CODE
#include "SourceTextView.h"
#include "MainFrame.h"
#include "ModuleGraphPage.h"
CViewManager::CViewManager():
Notebook()
{
	Menu::MenuList& mlMenuList = m_mwPopupMenu.items();
	mlMenuList.push_back( Menu_Helpers::MenuElem( "Refresh", sigc::mem_fun( *this, &CViewManager::OnRefreshMenu ) ) );
	mlMenuList.push_back( Menu_Helpers::MenuElem( "Refresh All", sigc::mem_fun( *this, &CViewManager::OnRefreshAllMenu ) ) );
	mlMenuList.push_back( Menu_Helpers::MenuElem( "Close", sigc::mem_fun( *this, &CViewManager::OnCloseMenu ) ) );
	mlMenuList.push_back( Menu_Helpers::MenuElem( "Close All But This", sigc::mem_fun( *this, &CViewManager::OnCloseAllButThisMenu ) ) );
	mlMenuList.push_back( Menu_Helpers::MenuElem( "Close All", sigc::mem_fun( *this, &CViewManager::OnCloseAllMenu ) ) );
	//  ?
	set_scrollable( true );
}
CViewManager::~CViewManager()
{

}
void CViewManager::AddModule()
{
	vector< Widget* > vecWidget = get_children();
	vector< Widget* >::iterator itWidget;
	vector< Widget* >::iterator itWidgetEnd = vecWidget.end();
	CModuleGraphPage* pModuleGraphPage;
	for ( itWidget = vecWidget.begin() ; itWidget != itWidgetEnd ; ++itWidget )
	{
		if ( ( *itWidget )->get_name() == "ModuleGraphPage" )
		{
			pModuleGraphPage = ( CModuleGraphPage* )( *itWidget );
			pModuleGraphPage->show();
			set_current_page( page_num( *pModuleGraphPage ) );
			pModuleGraphPage->FocusModuleGraphView();
			pModuleGraphPage->AddModule();
		}
	}
}
CModuleGraphView* CViewManager::GetModuleGraphView()
{
	vector< Widget* > vecWidget = get_children();
	vector< Widget* >::iterator itWidget;
	vector< Widget* >::iterator itWidgetEnd = vecWidget.end();
	CModuleGraphPage* pModuleGraphPage;
	for ( itWidget = vecWidget.begin() ; itWidget != itWidgetEnd ; ++itWidget )
	{
		if ( ( *itWidget )->get_name() == "ModuleGraphPage" )
		{
			pModuleGraphPage = ( CModuleGraphPage* )( *itWidget );
			return pModuleGraphPage->GetModuleGraphView();
		}
	}
	return NULL;
}
void CViewManager::AddModuleGraphView()
{
	g_pmfMainFrame->SetModified();
	vector< Widget* > vecWidget = get_children();
	vector< Widget* >::iterator itWidget;
	vector< Widget* >::iterator itWidgetEnd = vecWidget.end();
	CModuleGraphPage* pModuleGraphPage;
	for ( itWidget = vecWidget.begin() ; itWidget != itWidgetEnd ; ++itWidget )
	{
		if ( ( *itWidget )->get_name() == "ModuleGraphPage" )
		{
			pModuleGraphPage = ( CModuleGraphPage* )( *itWidget );
			pModuleGraphPage->show();
			set_current_page( page_num( *pModuleGraphPage ) );
			pModuleGraphPage->FocusModuleGraphView();
			return;
		}
	}
	pModuleGraphPage = manage( new CModuleGraphPage() );
	append_page( *pModuleGraphPage, *manage( new CNotebookLabel( "Module", "Module Graph View", (Widget*)pModuleGraphPage, -1 ) ) );
	pModuleGraphPage->set_name( "ModuleGraphPage" );
	set_tab_reorderable( *pModuleGraphPage );
	pModuleGraphPage->show();
	pModuleGraphPage->FocusModuleGraphView();
}
void CViewManager::AddSourceTextView( RefPtr< File > pFile, const ustring& strName, bool bDialog )
{
	vector< Widget* > vecWidget = get_children();
	vector< Widget* >::iterator itWidget;
	vector< Widget* >::iterator itWidgetEnd = vecWidget.end();
	CSourceTextView* pstpSourceTextView;
	for ( itWidget = vecWidget.begin() ; itWidget != itWidgetEnd ; ++itWidget )
	{
		if ( ( *itWidget )->get_name() == "SourceTextView" )
		{
			pstpSourceTextView = ( CSourceTextView* )( *itWidget );
			if ( pstpSourceTextView->GetFile()->equal( pFile ) == true )
			{
				pstpSourceTextView->show();
				set_current_page( page_num( *pstpSourceTextView ) );
				return;
			}
		}
	}
	pstpSourceTextView = manage( new CSourceTextView() );
	if ( pstpSourceTextView->SetFile( pFile, bDialog ) == false )
	{
		delete pstpSourceTextView;
		return;
	}
	pstpSourceTextView->set_name( "SourceTextView" );
	append_page( *pstpSourceTextView, *manage( new CNotebookLabel( "File", strName, (Widget*)pstpSourceTextView, -1 ) ) );
	pstpSourceTextView->show();
	set_current_page( page_num( *pstpSourceTextView ) );
	set_tab_reorderable( *pstpSourceTextView );
	g_pmfMainFrame->SetModified();
}

bool CViewManager::IsOpened( RefPtr< File > pFile )
{
	vector< Widget* > vecWidget = get_children();
	vector< Widget* >::iterator itWidget;
	vector< Widget* >::iterator itWidgetEnd = vecWidget.end();
	CSourceTextView* pstpSourceTextView;
	for ( itWidget = vecWidget.begin() ; itWidget != itWidgetEnd ; ++itWidget )
	{
		if ( ( *itWidget )->get_name() == "SourceTextView" )
		{
			pstpSourceTextView = ( CSourceTextView* )( *itWidget );
			if ( pstpSourceTextView->GetFile()->equal( pFile ) == true )
			{
				return pstpSourceTextView->is_visible();
			}
		}
	}
	return false;
}

bool CViewManager::IsSelected( RefPtr< File > pFile )
{
	int nNowPage = get_current_page();
	if ( nNowPage == -1 )
	{
		return false;
	}
	Widget* wCurrentPage = get_nth_page( nNowPage );
	CSourceTextView* pstpSourceTextView;
	if ( wCurrentPage->get_name() == "SourceTextView" )
	{
		pstpSourceTextView = ( CSourceTextView* )wCurrentPage;
		if ( pstpSourceTextView->is_visible() == true && pstpSourceTextView->GetFile()->equal( pFile ) == true )
		{
			return true;
		}
	}
	return false;
}
void CViewManager::SelectPage( RefPtr< File > pFile )
{
	vector< Widget* > vecWidget = get_children();
	vector< Widget* >::iterator itWidget;
	vector< Widget* >::iterator itWidgetEnd = vecWidget.end();
	CSourceTextView* pstpSourceTextView;
	for ( itWidget = vecWidget.begin() ; itWidget != itWidgetEnd ; ++itWidget )
	{
		if ( ( *itWidget )->get_name() == "SourceTextView" )
		{
			pstpSourceTextView = ( CSourceTextView* )( *itWidget );
			if ( pstpSourceTextView->GetFile()->equal( pFile ) == true )
			{
				pstpSourceTextView->show();
				set_current_page( page_num( *pstpSourceTextView ) );
				return;
			}
		}
	}
}
void CViewManager::on_switch_page( GtkNotebookPage* pnpNotebookPage, guint uiPageNumber )
{
	//g_pmfMainFrame->SetModified(); // ּ
	Notebook::on_switch_page( pnpNotebookPage, uiPageNumber );
}
bool CViewManager::on_button_press_event( GdkEventButton* pebEventButton )
{
	pebEventButton->button = 1;
	return Notebook::on_button_press_event( pebEventButton );
}
bool CViewManager::on_button_release_event( GdkEventButton* pebEventButton )
{
	if( pebEventButton->button == 3 )
	{
		m_mwPopupMenu.popup( pebEventButton->button, pebEventButton->time );
	}
	pebEventButton->button = 1;
	return Notebook::on_button_release_event( pebEventButton );
}
void CViewManager::OnRefreshMenu()
{
	Widget* wCurrentPage = get_nth_page( get_current_page() );
	CSourceTextView* pstpSourceTextView;
	if ( wCurrentPage->get_name() == "SourceTextView" )
	{
		pstpSourceTextView = ( CSourceTextView* )wCurrentPage;
		pstpSourceTextView->Refresh();
	}
}
void CViewManager::OnRefreshAllMenu()
{
	vector< Widget* > vecWidget = get_children();
	vector< Widget* >::iterator itWidget;
	vector< Widget* >::iterator itWidgetEnd = vecWidget.end();
	CSourceTextView* pstpSourceTextView;
	for ( itWidget = vecWidget.begin() ; itWidget != itWidgetEnd ; ++itWidget )
	{
		if ( ( *itWidget )->get_name() == "SourceTextView" )
		{
			pstpSourceTextView = ( CSourceTextView* )( *itWidget );
			pstpSourceTextView->Refresh();
		}
	}
}
void CViewManager::OnCloseMenu()
{
	get_nth_page( get_current_page() )->hide();
	queue_draw();
	g_pmfMainFrame->SetModified();
}
void CViewManager::OnCloseAllButThisMenu()
{
	Widget* wCurrentPage = get_nth_page( get_current_page() );
	OnCloseAllMenu();
	wCurrentPage->show();
	g_pmfMainFrame->SetModified();
}
void CViewManager::OnCloseAllMenu()
{
	vector< Widget* > vecWidget = get_children();
	vector< Widget* >::iterator itWidget;
	vector< Widget* >::iterator itWidgetEnd = vecWidget.end();
	for ( itWidget = vecWidget.begin() ; itWidget != itWidgetEnd ; ++itWidget )
	{
		( *itWidget )->hide();
	}
	queue_draw();
	g_pmfMainFrame->SetModified();
}


