#ifndef		__ANALAYSIS_MODULE_INTERFACE_H__
#define		__ANALAYSIS_MODULE_INTERFACE_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef NULL
#define NULL	0
#endif

#include "InOutPin.h"

class CAnalysisModuleInfo
{
public:
	CAnalysisModuleInfo()
	{
		memset ( this , 0x0 , sizeof ( CAnalysisModuleInfo ) );
	}
	~CAnalysisModuleInfo()
	{
	}

public:
	unsigned int	m_uiId;
	char			m_szName[128];
	unsigned int	m_uiRevisionNo;

	unsigned int	m_uiInputId;
	char			m_szInputName[256];
	char			m_szInputDescription[1024];

	unsigned int	m_uiOutputId;
	char			m_szOutputName[256];
	char			m_szOutputDescription[1024];
};

//typedef		

class CNotifyProcessState
{
public:
	CNotifyProcessState()
	{
		m_uiModuleId	= 0;
		m_nProcessRate	= 0;
		m_pszText		= NULL;
	}
	~CNotifyProcessState()
	{
		if ( m_pszText )
		{
			delete [] m_pszText;
			m_pszText = NULL;
		}
	}

public:
	unsigned int	m_uiModuleId;
	int				m_nProcessRate;
	char*			m_pszText;
};


class CModuleRelayInterface
{
public:
	CModuleRelayInterface()
	{
	}
	~CModuleRelayInterface()
	{
	}

	virtual void OnRelayResult ( unsigned int uiModuleId , CInOutPinBase* pOutPin ) = 0;
};

class CAnalysisNotifyInterface
{
public:
	CAnalysisNotifyInterface()
	{
	}
	~CAnalysisNotifyInterface()
	{
	}

	virtual void OnNotifyError ( unsigned int uiModuleId , unsigned int uiErrorNo , char* pErrorText ) = 0;
	virtual void OnNotifyAnalysisResult ( unsigned int uiModuleId , CAnalysisResultPin* pAnalysisResultPin ) = 0;
	virtual void OnNotifyProcessState ( CNotifyProcessState* pProcessState ) = 0;
};

#define		FN_GetModuleInfo		"GetModuleInfo"
#define		FN_Initialize			"Initialize"
#define		FN_StartProcess			"StartProcess"
#define		FN_StopProcess			"StopProcess"
#define		FN_SetOption			"SetOption"
// add
#define		FN_GetOption			"GetOption"
//
#define		FN_GetStatus			"GetStatus"

typedef bool	(*FP_GetModuleInfo)( CAnalysisModuleInfo* pInfo );
typedef void	(*FP_Initialize)( CAnalysisNotifyInterface* pInterface , CModuleRelayInterface* pRelayInterface );
typedef bool	(*FP_StartProcess)( CInOutPinBase* pInputPin );
// typedef void	(*FP_StopProcess)();
typedef bool	(*FP_StopProcess)();
typedef void	(*FP_SetOption)( char* pszOption );
typedef char*	(*FP_GetOption)();
typedef int	(*FP_GetStatus)();

// SetOption GetOption ڿ Ģ
// "OptionName1$OptionValue1#OptionName2$OptionValue2#....#OptionNamen$OptionValuen#



#endif // __ANALAYSIS_MODULE_INTERFACE_H__
