#ifndef		__IN_OUT_PIN_H__
#define		__IN_OUT_PIN_H__

#define		SOURCE_FILENAME_SEPERATOR		","

// In-Out Pin(IOP) ID Definition
enum
{
	IOP_UNKNOWN = 0 ,
	IOP_SOURCE_FILES ,
	IOP_ANALYSIS_RESULT ,
	IOP_USER ,
};

#define PIN_NAME_SOURCE_FILE		"SourceFilePin"
#define PIN_NAME_ANALYSIS_RESULT	"AnalysisResultPin"

class CInOutPinBase
{
public:
	CInOutPinBase()
	{
		memset ( m_szName , 0x0 , sizeof ( m_szName ) );
		m_uiId		= IOP_UNKNOWN;
		m_uiSize	= 0;
	}

	virtual ~CInOutPinBase()
	{
	}

public:
	unsigned int	m_uiId;
	char			m_szName[128];
	unsigned int	m_uiSize;
};


class CSourceFilePin : public CInOutPinBase
{
public:
	CSourceFilePin() : CInOutPinBase()
	{
		m_uiId				= IOP_SOURCE_FILES;
		m_pszFileName		= NULL;
	}

	virtual ~CSourceFilePin()
	{
		if ( m_pszFileName )
		{
			delete [] m_pszFileName;
			m_pszFileName = NULL;
		}
	}

	int			m_nFileCount;	
	char*		m_pszFileName;
};

class CAnalysisResultPin : public CInOutPinBase
{
public:
	CAnalysisResultPin() : CInOutPinBase()
	{
		m_uiId			= IOP_ANALYSIS_RESULT;
		m_pszFileName	= NULL;
		m_nLineNo		= 0;
		m_pszErrorText	= NULL;
	}

	virtual ~CAnalysisResultPin()
	{
		if ( m_pszFileName )
		{
			delete [] m_pszFileName;
			m_pszFileName = NULL;
		}

		if ( m_pszErrorText )
		{
			delete [] m_pszErrorText;
			m_pszErrorText = NULL;
		}
	}
	
	char*		m_pszFileName;
	int			m_nLineNo;
	char*		m_pszErrorText;
};

#endif // __IN_OUT_PIN_H__
