// #include <varargs.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_ARG_SIZE 10

void PrintfEx( const char* pFmt , ... )
{
	va_list ptr;	

	char* pszBuf	= NULL;

	int nRt 	= 0;
	int nBeforeRt	= MAX_ARG_SIZE;

	va_start( ptr , pFmt );

	pszBuf = ( char* )malloc( nBeforeRt );
	memset( pszBuf , 0 , sizeof( pszBuf ) );

	nRt = vsnprintf( pszBuf , nBeforeRt , pFmt , ptr );
	while( nRt >= nBeforeRt )
	{
		if( pszBuf )
		{
			delete [] pszBuf;
			pszBuf = NULL;
		}

		pszBuf = ( char* )malloc( nRt + 1 );
		memset( pszBuf , 0 , nRt + 1 );

		nBeforeRt = nRt + 1;		
		nRt = vsnprintf( pszBuf , nRt + 1 , pFmt , ptr );
	}

	printf( "%s" , pszBuf );
	printf( "nRt = %d\n" , nRt );

	va_end( ptr );
}

int main()
{
	int a = 1;
	int b = 2;

	PrintfEx( "Test 1 = %d , Test 2 = %d\n" , a , b );
	
	return 0;
}
